unit unewgame;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Buttons, ugomain, ulocale, usaveload2;

type

  { TForm2 }

  TForm2 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    ColorDialog1: TColorDialog;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    Edit1: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit16: TEdit;
    Edit17: TEdit;
    Edit18: TEdit;
    Edit19: TEdit;
    Edit2: TEdit;
    Edit20: TEdit;
    Edit21: TEdit;
    Edit22: TEdit;
    Edit23: TEdit;
    Edit24: TEdit;
    Edit25: TEdit;
    Edit26: TEdit;
    Edit27: TEdit;
    Edit28: TEdit;
    Edit29: TEdit;
    Edit3: TEdit;
    Edit30: TEdit;
    Edit31: TEdit;
    Edit32: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    Image1: TImage;
    Image2: TImage;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label3: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    SpeedButton1: TSpeedButton;
    procedure Button5Click(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox3Click(Sender: TObject);
    procedure ComboBox3Select(Sender: TObject);
    procedure DefineLangs;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
    procedure CheckBox3Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure GroupBox6Click(Sender: TObject);
    procedure Label11Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.lfm}

{ TForm2 }

procedure TForm2.Button1Click(Sender: TObject);
begin
  if ColorDialog1.Execute then
  begin
    plr[ComboBox1.ItemIndex].color:=ColorDialog1.Color;
  end;
end;

procedure TForm2.Button2Click(Sender: TObject);
var i,n:integer;
begin
  //maxpl:=strtoint(Edit4.Text);
  bnouselesssectors:=CheckBox5.Checked;
  camx:=0;
  camy:=0;
  ig:=true;
  gw:=strtoint(edit2.Text);
  gh:=strtoint(edit3.Text);
  minpprice:=strtoint(Edit4.Text);
  maxpprice:=strtoint(Edit5.Text);
  prflux:=strtoint(Edit24.Text);
  form1.cleangamedata;
  Form1.Panel1.Enabled:=true;
  if CheckBox1.Checked then
  begin
    plr[0].color:=clRed;
    plr[1].color:=clAqua;
    plr[2].color:=clGreen;
    plr[3].color:=clYellow;
    plr[4].color:=clLime;
    plr[5].color:=clMaroon;
    plr[6].color:=clOlive;
    plr[7].color:=clTeal;
    plr[8].color:=clDkGray;
    plr[9].color:=clWhite;
  end;
  if CheckBox6.Checked=true then
  begin
    n:=StrToInt(edit1.text)-1;
    for i:=0 to n do
    begin
      plr[i].team:=random(ComboBox3.Items.Count);
    end;
  end;
  if CheckBox2.Checked=true then
    Form1.startgame(strtoint(Edit1.Text),true,strtoint(Edit13.Text),strtoint(Edit14.Text))
  else
    Form1.startgame(strtoint(Edit1.Text),false,strtoint(Edit13.Text),strtoint(Edit14.Text));
  mm:=false;
  Edit1.Enabled:=false;
  //calculating cage scale!
  if form1.image1.Height<Form1.Image1.Width then
    if (gw-gh<0) then
      scl:=Form1.Image1.Height div gh
    else
      scl:=Form1.Image1.Height div gw
  else
    if (gw-gh<0) then
      scl:=Form1.Image1.Width div gh
    else
      scl:=Form1.Image1.Width div gw;
  Form1.TrackBar1.Position:=scl;
  Form2.Close;
  Form1.Showbriefing('skirmish',cloc);
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  flcm:=        strtofloat(edit7.Text);
  bassp:=       strtofloat(edit8.Text);
  bassecm:=     strtofloat(edit9.Text);
  basflap:=     strtofloat(edit10.Text);
  basflp:=      strtofloat(edit11.Text);
  basfsm:=      strtofloat(edit12.Text);
  sfcm:=        strtoint(edit15.text);
  sfcp:=        strtoint(edit16.text);
  smplim:=      strtoint(edit17.text);
  fpowlim:=     strtoint(edit18.text);
  ballowrandom:=CheckBox4.Checked;
  bbasehp:=     strtoint(edit19.text);
  bbasedmg:=    strtoint(edit20.text);
  bbdmg:=       strtoint(edit21.text);
  bclmc:=       strtoint(Edit22.Text);
  bclpc:=       strtoint(Edit23.Text);
  bssmlt:=      1;
  barc:=        StrToInt(Edit25.Text);
  btechlim:=    StrToInt(Edit26.Text);
  bbslim:=      StrToInt(Edit27.Text);
  bbscostm:=    StrToInt(Edit28.Text);
  bbscostp:=    StrToInt(Edit31.Text);
  bbsmult:=     strtofloat(edit29.Text);
  bbssuppcst:=  StrToInt(Edit30.Text);
  bbshpmult:=   strtofloat(edit32.Text);
end;

procedure TForm2.Button4Click(Sender: TObject);
begin
  Edit7.Text:='2';
  Edit8.Text:='1';
  Edit9.Text:='1';
  Edit10.Text:='1';
  Edit11.Text:='1';
  Edit12.Text:='1';
  Edit15.Text:='10';
  Edit16.Text:='10';
  Edit17.Text:='10';
  Edit18.Text:='50';
  Edit19.Text:='100';
  Edit20.Text:='20';
  Edit21.Text:='60';
  Edit22.Text:='10';
  Edit23.Text:='0';
  Edit25.Text:='10000';
  Edit26.Text:='10';
  Edit27.Text:='5';
  Edit28.Text:='1300';
  Edit29.Text:='1,5';
  Edit30.Text:='50';
  Edit31.Text:='500';
  Edit32.Text:='10';
  CheckBox4.Checked:=false;
end;

procedure TForm2.CheckBox1Change(Sender: TObject);
begin
  plr[0].color:=clRed;
  plr[1].color:=clAqua;
  plr[2].color:=clGreen;
  plr[3].color:=clYellow;
  plr[4].color:=clLime;
  plr[5].color:=clMaroon;
  plr[6].color:=clOlive;
  plr[7].color:=clTeal;
  plr[8].color:=clDkGray;
  plr[9].color:=clWhite;
end;

procedure TForm2.CheckBox3Change(Sender: TObject);
begin
  plr[ComboBox1.ItemIndex].human:=CheckBox3.Checked;
end;

procedure TForm2.ComboBox1Change(Sender: TObject);
begin
  if plr[ComboBox1.ItemIndex].human=true then Label5.Caption:=strarr[55]
  else Label5.Caption:=strarr[56];
  Form2.ComboBox3.Text:=Form2.ComboBox3.Items[plr[Form2.ComboBox1.ItemIndex].team];
end;

procedure TForm2.Edit6Change(Sender: TObject);
begin
  plr[ComboBox1.ItemIndex].name:=Edit6.Text;
end;

procedure TForm2.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  edit1.Enabled:=false;
end;

procedure TForm2.DefineLangs;
var fts:string;
    i:integer=0;
begin
  ComboBox2.Items.Clear;
  fts:=ExtractFileDir(Application.ExeName)+'\locales\locale_';
  while FileExists(fts+inttostr(i)+'.txt') do
  begin
    Form7.Memo1.Lines.LoadFromFile(fts+inttostr(i)+'.txt');
    ComboBox2.Items.Add(Form7.Memo1.Lines[0]); i:=i+1;
  end;
end;

procedure TForm2.Button5Click(Sender: TObject);
begin
  with Form7 do
  begin
    LoadLocales(ComboBox2.ItemIndex,1);
    ReadLocales;
  end;
  with form10.Memo1.Lines do
  begin
    clear;
    add(inttostr(cloc));
    SaveToFile(extractfiledir(Application.ExeName)+'\gameconfig.cfg');
    clear;
  end;
end;

procedure TForm2.ComboBox2Change(Sender: TObject);
begin
  Label28.Caption:=inttostr(ComboBox2.ItemIndex);
end;

procedure TForm2.ComboBox3Change(Sender: TObject);
begin

end;

procedure TForm2.ComboBox3Click(Sender: TObject);
var i:integer;
    f:boolean=true;
    t:string;
begin

end;

procedure TForm2.ComboBox3Select(Sender: TObject);
begin
  plr[ComboBox1.ItemIndex].team:=ComboBox3.ItemIndex;
end;

procedure TForm2.FormShow(Sender: TObject);
var pw,ph,i1w,i1h:integer;
begin
  DefineLangs;

  {if basloc=-1 then
  begin
    basloc:=0;
    Form7.LoadLocales(basloc,1);
    Form7.ReadLocales;
  end;       }

  globalpng:=TPortableNetworkGraphic.Create;
  globalpng.LoadFromFile(extractfiledir(Application.ExeName)+'/go_logo.png');
  pw:=globalpng.Width;
  ph:=globalpng.Height;
  i1w:=Image2.Width;
  i1h:=Image2.Height;
  Image2.Canvas.Brush.Color:=Form2.Color;
  Image2.Canvas.Pen.Color:=Form2.Color;
  Image2.Canvas.Rectangle(0,0,Image2.Width,Image2.Height);
  Image2.Canvas.CopyRect(Rect(round((i1w/2)-(pw/2)),
                              round((i1h/2)-(ph/2)),
                              round((i1w/2)+(pw/2)),
                              round((i1h/2)+(ph/2))),
                         globalpng.Canvas,
                         Rect(0,0,pw,ph));
  FreeAndNil(globalpng);
  edit1.Enabled:=true; Form2.ComboBox3.Text:=Form2.ComboBox3.Items[plr[Form2.ComboBox1.ItemIndex].team];
end;

procedure TForm2.GroupBox6Click(Sender: TObject);
begin

end;

procedure TForm2.Label11Click(Sender: TObject);
begin

end;

procedure TForm2.SpeedButton1Click(Sender: TObject);
begin
  Case ComboBox3.ItemIndex of
  0: MessageDlg(strarr[114+ComboBox3.ItemIndex],mtInformation,[mbOK],0);
  1: MessageDlg(strarr[114+ComboBox3.ItemIndex],mtInformation,[mbOK],0);
  2: MessageDlg(strarr[114+ComboBox3.ItemIndex],mtInformation,[mbOK],0);
  3: MessageDlg(strarr[136],mtInformation,[mbOK],0);
  4: MessageDlg(strarr[136],mtInformation,[mbOK],0);
  end;
end;

end.

