unit unewgame2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls,ugomain,unewgame;

type

  { TForm13 }

  TForm13 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    ListBox1: TListBox;
    Memo1: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox1SelectionChange(Sender: TObject; User: boolean);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form13: TForm13;


implementation

{$R *.lfm}

{ TForm13 }

procedure TForm13.FormActivate(Sender: TObject);
var i,l,i1w,i1h,pw,ph:integer;
    ftc,emsg:string;
begin
  //topimage
  globalpng:=TPortableNetworkGraphic.Create;
  globalpng.LoadFromFile(extractfiledir(Application.ExeName)+'/go_logo.png');
  pw:=globalpng.Width;
  ph:=globalpng.Height;
  i1w:=Image1.Width;
  i1h:=Image1.Height;
  Image1.Canvas.Brush.Color:=Form2.Color;
  Image1.Canvas.Pen.Color:=Form2.Color;
  Image1.Canvas.Rectangle(0,0,Image1.Width,Image1.Height);
  Image1.Canvas.CopyRect(Rect(round((i1w/2)-(pw/2)),
                              round((i1h/2)-(ph/2)),
                              round((i1w/2)+(pw/2)),
                              round((i1h/2)+(ph/2))),
                         globalpng.Canvas,
                         Rect(0,0,pw,ph));
  FreeAndNil(globalpng);
  //campaign menu
  ftc:=extractfiledir(application.exename)+'\campmanifest_'+inttostr(cloc)+'.txt';
  if fileexists(ftc)=true then
  begin
    Memo1.Lines.LoadFromFile(ftc);
    l:=0;
    ListBox1.Items.Clear;
    for i:=0 to round(Memo1.Lines.Count/2)-1 do
    begin
      ListBox1.Items.Add(Memo1.Lines[l]);
      camparr[i]:=Memo1.Lines[l+1];
      l:=l+2;
    end;
    Memo1.Lines.Clear;
  end
  else
  begin
    emsg:='File not found: '+ftc;
    MessageDlg(AnsiString(emsg),mtError,[mbOK],0);
  end;

end;

procedure TForm13.ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var ftc:string;
begin
  ftc:=extractfiledir(Application.ExeName)+'\'+camparr[ListBox1.ItemIndex]+'\description_'+inttostr(cloc)+'.txt';
  if fileexists(ftc)=true then
  begin
    Memo1.Lines.LoadFromFile(ftc);
  end
  else
  begin
    Memo1.Lines.Clear;
    //ShowMessage('No campaign selected! FTC: '+ftc+'; ListBox1.ItemIndex: '+inttostr(ListBox1.ItemIndex));
  end;
end;

procedure TForm13.ListBox1SelectionChange(Sender: TObject; User: boolean);

begin

end;

procedure TForm13.Button2Click(Sender: TObject);
begin
  if  Form1.OpenDialog1.Execute THEN
  begin
    Form1.LoadGame(Form1.OpenDialog1.FileName);
    Form13.Hide;
  end;
end;

procedure TForm13.Button1Click(Sender: TObject);
var ftc:string;
begin
  ftc:=extractfiledir(Application.ExeName)+'\'+camparr[ListBox1.ItemIndex]+'\c1_m1.sav';
  if fileexists(ftc)=true then
  begin
    Form1.LoadGame(ftc);
    Form13.Hide;
  end
  else Memo1.Lines.Clear;
end;

procedure TForm13.Button3Click(Sender: TObject);
begin
  Form2.Show;
  Form13.Hide;
end;

end.

